## slic3r-prusa 1.39.0+dfsg

=== xs/CMakeLists.txt ===
# Enable C++11 language standard.
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Add our own cmake module path.
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake/modules/)

if (CMAKE_SYSTEM_NAME STREQUAL "Linux")
    # Workaround for an old CMake, which does not understand CMAKE_CXX_STANDARD.
    add_compile_options(-std=c++11 -Wall)
endif()

if (CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUXX)
    # Adding -fext-numeric-literals to enable GCC extensions on definitions of quad float literals, which are required by Boost.
    add_compile_options(-fext-numeric-literals)
endif()

# Where all the bundled libraries reside?
set(LIBDIR ${CMAKE_CURRENT_SOURCE_DIR}/src/)
# For the bundled boost libraries (boost::nowide)
include_directories(${LIBDIR})
# For libslic3r.h
include_directories(${LIBDIR}/libslic3r)
#set(CMAKE_INCLUDE_CURRENT_DIR ON)

if(WIN32)
    # BOOST_ALL_NO_LIB: Avoid the automatic linking of Boost libraries on Windows. Rather rely on explicit linking.
    add_definitions(-D_USE_MATH_DEFINES -D_WIN32 -DBOOST_ALL_NO_LIB)
endif()

add_definitions(-DwxUSE_UNICODE -D_UNICODE -DUNICODE)

add_library(libslic3r STATIC
    ${LIBDIR}/libslic3r/BoundingBox.cpp
    ${LIBDIR}/libslic3r/BoundingBox.hpp
    ${LIBDIR}/libslic3r/BridgeDetector.cpp
    ${LIBDIR}/libslic3r/BridgeDetector.hpp
    ${LIBDIR}/libslic3r/ClipperUtils.cpp
    ${LIBDIR}/libslic3r/ClipperUtils.hpp
    ${LIBDIR}/libslic3r/Config.cpp
    ${LIBDIR}/libslic3r/Config.hpp
    ${LIBDIR}/libslic3r/EdgeGrid.cpp
    ${LIBDIR}/libslic3r/EdgeGrid.hpp
    ${LIBDIR}/libslic3r/ExPolygon.cpp
    ${LIBDIR}/libslic3r/ExPolygon.hpp
    ${LIBDIR}/libslic3r/ExPolygonCollection.cpp
    ${LIBDIR}/libslic3r/ExPolygonCollection.hpp
    ${LIBDIR}/libslic3r/Extruder.cpp
    ${LIBDIR}/libslic3r/Extruder.hpp
    ${LIBDIR}/libslic3r/ExtrusionEntity.cpp
    ${LIBDIR}/libslic3r/ExtrusionEntity.hpp
    ${LIBDIR}/libslic3r/ExtrusionEntityCollection.cpp
    ${LIBDIR}/libslic3r/ExtrusionEntityCollection.hpp
    ${LIBDIR}/libslic3r/ExtrusionSimulator.cpp
    ${LIBDIR}/libslic3r/ExtrusionSimulator.hpp
    ${LIBDIR}/libslic3r/Fill/Fill.cpp
    ${LIBDIR}/libslic3r/Fill/Fill.hpp
    ${LIBDIR}/libslic3r/Fill/Fill3DHoneycomb.cpp
    ${LIBDIR}/libslic3r/Fill/Fill3DHoneycomb.hpp
    ${LIBDIR}/libslic3r/Fill/FillBase.cpp
    ${LIBDIR}/libslic3r/Fill/FillBase.hpp
    ${LIBDIR}/libslic3r/Fill/FillConcentric.cpp
    ${LIBDIR}/libslic3r/Fill/FillConcentric.hpp
    ${LIBDIR}/libslic3r/Fill/FillHoneycomb.cpp
    ${LIBDIR}/libslic3r/Fill/FillHoneycomb.hpp
    ${LIBDIR}/libslic3r/Fill/FillPlanePath.cpp
    ${LIBDIR}/libslic3r/Fill/FillPlanePath.hpp
    ${LIBDIR}/libslic3r/Fill/FillRectilinear.cpp
    ${LIBDIR}/libslic3r/Fill/FillRectilinear.hpp
    ${LIBDIR}/libslic3r/Fill/FillRectilinear2.cpp
    ${LIBDIR}/libslic3r/Fill/FillRectilinear2.hpp
    ${LIBDIR}/libslic3r/Fill/FillRectilinear3.cpp
    ${LIBDIR}/libslic3r/Fill/FillRectilinear3.hpp
    ${LIBDIR}/libslic3r/Flow.cpp
    ${LIBDIR}/libslic3r/Flow.hpp
    ${LIBDIR}/libslic3r/Format/AMF.cpp
    ${LIBDIR}/libslic3r/Format/AMF.hpp
    ${LIBDIR}/libslic3r/Format/OBJ.cpp
    ${LIBDIR}/libslic3r/Format/OBJ.hpp
    ${LIBDIR}/libslic3r/Format/objparser.cpp
    ${LIBDIR}/libslic3r/Format/objparser.hpp
    ${LIBDIR}/libslic3r/Format/PRUS.cpp
    ${LIBDIR}/libslic3r/Format/PRUS.hpp
    ${LIBDIR}/libslic3r/Format/STL.cpp
    ${LIBDIR}/libslic3r/Format/STL.hpp
    ${LIBDIR}/libslic3r/GCode/Analyzer.cpp
    ${LIBDIR}/libslic3r/GCode/Analyzer.hpp
    ${LIBDIR}/libslic3r/GCode/CoolingBuffer.cpp
    ${LIBDIR}/libslic3r/GCode/CoolingBuffer.hpp
    ${LIBDIR}/libslic3r/GCode/PressureEqualizer.cpp
    ${LIBDIR}/libslic3r/GCode/PressureEqualizer.hpp
    ${LIBDIR}/libslic3r/GCode/PrintExtents.cpp
    ${LIBDIR}/libslic3r/GCode/PrintExtents.hpp
    ${LIBDIR}/libslic3r/GCode/SpiralVase.cpp
    ${LIBDIR}/libslic3r/GCode/SpiralVase.hpp
    ${LIBDIR}/libslic3r/GCode/ToolOrdering.cpp
    ${LIBDIR}/libslic3r/GCode/ToolOrdering.hpp
    ${LIBDIR}/libslic3r/GCode/WipeTower.hpp
    ${LIBDIR}/libslic3r/GCode/WipeTowerPrusaMM.cpp
    ${LIBDIR}/libslic3r/GCode/WipeTowerPrusaMM.hpp
    ${LIBDIR}/libslic3r/GCode.cpp
    ${LIBDIR}/libslic3r/GCode.hpp
    ${LIBDIR}/libslic3r/GCodeReader.cpp
    ${LIBDIR}/libslic3r/GCodeReader.hpp
    ${LIBDIR}/libslic3r/GCodeSender.cpp
    ${LIBDIR}/libslic3r/GCodeSender.hpp
    ${LIBDIR}/libslic3r/GCodeTimeEstimator.cpp
    ${LIBDIR}/libslic3r/GCodeTimeEstimator.hpp
    ${LIBDIR}/libslic3r/GCodeWriter.cpp
    ${LIBDIR}/libslic3r/GCodeWriter.hpp
    ${LIBDIR}/libslic3r/Geometry.cpp
    ${LIBDIR}/libslic3r/Geometry.hpp
    ${LIBDIR}/libslic3r/Int128.hpp
#    ${LIBDIR}/libslic3r/KdTree.hpp
    ${LIBDIR}/libslic3r/Layer.cpp
    ${LIBDIR}/libslic3r/Layer.hpp
    ${LIBDIR}/libslic3r/LayerRegion.cpp
    ${LIBDIR}/libslic3r/libslic3r.h
    ${LIBDIR}/libslic3r/Line.cpp
    ${LIBDIR}/libslic3r/Line.hpp
    ${LIBDIR}/libslic3r/Model.cpp
    ${LIBDIR}/libslic3r/Model.hpp
    ${LIBDIR}/libslic3r/MotionPlanner.cpp
    ${LIBDIR}/libslic3r/MotionPlanner.hpp
    ${LIBDIR}/libslic3r/MultiPoint.cpp
    ${LIBDIR}/libslic3r/MultiPoint.hpp
    ${LIBDIR}/libslic3r/MutablePriorityQueue.hpp
    ${LIBDIR}/libslic3r/PerimeterGenerator.cpp
    ${LIBDIR}/libslic3r/PerimeterGenerator.hpp
    ${LIBDIR}/libslic3r/PlaceholderParser.cpp
    ${LIBDIR}/libslic3r/PlaceholderParser.hpp
    ${LIBDIR}/libslic3r/Point.cpp
    ${LIBDIR}/libslic3r/Point.hpp
    ${LIBDIR}/libslic3r/Polygon.cpp
    ${LIBDIR}/libslic3r/Polygon.hpp
    ${LIBDIR}/libslic3r/Polyline.cpp
    ${LIBDIR}/libslic3r/Polyline.hpp
    ${LIBDIR}/libslic3r/PolylineCollection.cpp
    ${LIBDIR}/libslic3r/PolylineCollection.hpp
    ${LIBDIR}/libslic3r/Print.cpp
    ${LIBDIR}/libslic3r/Print.hpp
    ${LIBDIR}/libslic3r/PrintConfig.cpp
    ${LIBDIR}/libslic3r/PrintConfig.hpp
    ${LIBDIR}/libslic3r/PrintObject.cpp
    ${LIBDIR}/libslic3r/PrintRegion.cpp
    ${LIBDIR}/libslic3r/Slicing.cpp
    ${LIBDIR}/libslic3r/Slicing.hpp
    ${LIBDIR}/libslic3r/SlicingAdaptive.cpp
    ${LIBDIR}/libslic3r/SlicingAdaptive.hpp
    ${LIBDIR}/libslic3r/SupportMaterial.cpp
    ${LIBDIR}/libslic3r/SupportMaterial.hpp
    ${LIBDIR}/libslic3r/Surface.cpp
    ${LIBDIR}/libslic3r/Surface.hpp
    ${LIBDIR}/libslic3r/SurfaceCollection.cpp
    ${LIBDIR}/libslic3r/SurfaceCollection.hpp
    ${LIBDIR}/libslic3r/SVG.cpp
    ${LIBDIR}/libslic3r/SVG.hpp
    ${LIBDIR}/libslic3r/TriangleMesh.cpp
    ${LIBDIR}/libslic3r/TriangleMesh.hpp
#    ${LIBDIR}/libslic3r/utils.cpp
    ${LIBDIR}/libslic3r/Utils.hpp
)

add_library(libslic3r_gui STATIC
    ${LIBDIR}/slic3r/GUI/3DScene.cpp
    ${LIBDIR}/slic3r/GUI/3DScene.hpp
    ${LIBDIR}/slic3r/GUI/GLShader.cpp
    ${LIBDIR}/slic3r/GUI/GLShader.hpp
    ${LIBDIR}/slic3r/GUI/Preset.cpp
    ${LIBDIR}/slic3r/GUI/Preset.hpp
    ${LIBDIR}/slic3r/GUI/GUI.cpp
    ${LIBDIR}/slic3r/GUI/GUI.hpp
)

add_library(admesh STATIC
    ${LIBDIR}/admesh/connect.cpp
    ${LIBDIR}/admesh/normals.cpp
    ${LIBDIR}/admesh/shared.cpp
    ${LIBDIR}/admesh/stl.h
    ${LIBDIR}/admesh/stl_io.cpp
    ${LIBDIR}/admesh/stlinit.cpp
    ${LIBDIR}/admesh/util.cpp
)

add_library(clipper STATIC 
    ${LIBDIR}/clipper.cpp
    ${LIBDIR}/clipper.hpp
)

add_library(polypartition STATIC 
    ${LIBDIR}/polypartition.cpp
    ${LIBDIR}/polypartition.h
)

add_library(poly2tri STATIC
    ${LIBDIR}/poly2tri/common/shapes.cc
    ${LIBDIR}/poly2tri/common/shapes.h
    ${LIBDIR}/poly2tri/common/utils.h
    ${LIBDIR}/poly2tri/poly2tri.h
    ${LIBDIR}/poly2tri/sweep/advancing_front.cc
    ${LIBDIR}/poly2tri/sweep/advancing_front.h
    ${LIBDIR}/poly2tri/sweep/cdt.cc
    ${LIBDIR}/poly2tri/sweep/cdt.h
    ${LIBDIR}/poly2tri/sweep/sweep.cc
    ${LIBDIR}/poly2tri/sweep/sweep.h
    ${LIBDIR}/poly2tri/sweep/sweep_context.cc
    ${LIBDIR}/poly2tri/sweep/sweep_context.h
)

add_library(nowide STATIC
    ${LIBDIR}/boost/nowide/args.hpp
    ${LIBDIR}/boost/nowide/cenv.hpp
    ${LIBDIR}/boost/nowide/config.hpp
    ${LIBDIR}/boost/nowide/convert.hpp
    ${LIBDIR}/boost/nowide/cstdio.hpp
    ${LIBDIR}/boost/nowide/cstdlib.hpp
    ${LIBDIR}/boost/nowide/filebuf.hpp
    ${LIBDIR}/boost/nowide/fstream.hpp
    ${LIBDIR}/boost/nowide/integration/filesystem.hpp
    ${LIBDIR}/boost/nowide/iostream.cpp
    ${LIBDIR}/boost/nowide/iostream.hpp
    ${LIBDIR}/boost/nowide/stackstring.hpp
    ${LIBDIR}/boost/nowide/system.hpp
    ${LIBDIR}/boost/nowide/utf8_codecvt.hpp
    ${LIBDIR}/boost/nowide/windows.hpp
)

add_library(Shiny STATIC
    ${LIBDIR}/Shiny/Shiny.h
    ${LIBDIR}/Shiny/ShinyConfig.h
    ${LIBDIR}/Shiny/ShinyData.h
    ${LIBDIR}/Shiny/ShinyMacros.h
    ${LIBDIR}/Shiny/ShinyManager.c
    ${LIBDIR}/Shiny/ShinyManager.h
    ${LIBDIR}/Shiny/ShinyNode.c
    ${LIBDIR}/Shiny/ShinyNode.h
    ${LIBDIR}/Shiny/ShinyNodePool.c
    ${LIBDIR}/Shiny/ShinyNodePool.h
    ${LIBDIR}/Shiny/ShinyNodeState.c
    ${LIBDIR}/Shiny/ShinyNodeState.h
    ${LIBDIR}/Shiny/ShinyOutput.c
    ${LIBDIR}/Shiny/ShinyOutput.h
    ${LIBDIR}/Shiny/ShinyPrereqs.h
    ${LIBDIR}/Shiny/ShinyTools.c
    ${LIBDIR}/Shiny/ShinyTools.h
    ${LIBDIR}/Shiny/ShinyVersion.h
    ${LIBDIR}/Shiny/ShinyZone.c
    ${LIBDIR}/Shiny/ShinyZone.h
)

# Generate the Slic3r Perl module (XS) typemap file.
set(MyTypemap ${CMAKE_CURRENT_BINARY_DIR}/typemap)
add_custom_command(
        OUTPUT ${MyTypemap}
        DEPENDS ${CMAKE_CURRENT_LIST_DIR}/xsp/my.map
        COMMAND ${PERL_EXECUTABLE} -MExtUtils::Typemaps -MExtUtils::Typemaps::Basic -e "$typemap = ExtUtils::Typemaps->new(file => \"${CMAKE_CURRENT_LIST_DIR}/xsp/my.map\"); $typemap->merge(typemap => ExtUtils::Typemaps::Basic->new); $typemap->write(file => \"${MyTypemap}\")"
        VERBATIM
)

# Generate the Slic3r Perl module (XS) main.xs file.
set(XS_MAIN_XS ${CMAKE_CURRENT_BINARY_DIR}/main.xs)
set(XSP_DIR ${CMAKE_CURRENT_SOURCE_DIR}/xsp)
#FIXME list the dependecies explicitely, add dependency on the typemap.
set(XS_XSP_FILES
    ${XSP_DIR}/BoundingBox.xsp
    ${XSP_DIR}/BridgeDetector.xsp
    ${XSP_DIR}/Clipper.xsp
    ${XSP_DIR}/Config.xsp
    ${XSP_DIR}/ExPolygon.xsp
    ${XSP_DIR}/ExPolygonCollection.xsp
    ${XSP_DIR}/ExtrusionEntityCollection.xsp
    ${XSP_DIR}/ExtrusionLoop.xsp
    ${XSP_DIR}/ExtrusionMultiPath.xsp
    ${XSP_DIR}/ExtrusionPath.xsp
    ${XSP_DIR}/ExtrusionSimulator.xsp
    ${XSP_DIR}/Filler.xsp
    ${XSP_DIR}/Flow.xsp
    ${XSP_DIR}/GCode.xsp
    ${XSP_DIR}/GCodeSender.xsp
    ${XSP_DIR}/Geometry.xsp
    ${XSP_DIR}/GUI.xsp
    ${XSP_DIR}/GUI_3DScene.xsp
    ${XSP_DIR}/GUI_Preset.xsp
    ${XSP_DIR}/Layer.xsp
    ${XSP_DIR}/Line.xsp
    ${XSP_DIR}/Model.xsp
    ${XSP_DIR}/MotionPlanner.xsp
    ${XSP_DIR}/PerimeterGenerator.xsp
    ${XSP_DIR}/PlaceholderParser.xsp
    ${XSP_DIR}/Point.xsp
    ${XSP_DIR}/Polygon.xsp
    ${XSP_DIR}/Polyline.xsp
    ${XSP_DIR}/PolylineCollection.xsp
    ${XSP_DIR}/Print.xsp
    ${XSP_DIR}/Surface.xsp
    ${XSP_DIR}/SurfaceCollection.xsp
    ${XSP_DIR}/TriangleMesh.xsp
    ${XSP_DIR}/XS.xsp
)
foreach (file ${XS_XSP_FILES})
    if (MSVC)
        # Visual Studio C compiler has issues with FILE pragmas containing quotes.
        set(INCLUDE_COMMANDS "${INCLUDE_COMMANDS}INCLUDE_COMMAND: $^X -MExtUtils::XSpp::Cmd -e xspp -- -t ${CMAKE_CURRENT_LIST_DIR}/xsp/typemap.xspt ${file}\n")
    else ()
        set(INCLUDE_COMMANDS "${INCLUDE_COMMANDS}INCLUDE_COMMAND: $^X -MExtUtils::XSpp::Cmd -e xspp -- -t \"${CMAKE_CURRENT_LIST_DIR}/xsp/typemap.xspt\" \"${file}\"\n")
    endif ()
endforeach ()
configure_file(main.xs.in ${XS_MAIN_XS} @ONLY) # Insert INCLUDE_COMMANDS into main.xs

# Generate the Slic3r Perl module (XS) XS.cpp file.
#FIXME add the dependency on main.xs and typemap.
set(XS_MAIN_CPP ${CMAKE_CURRENT_BINARY_DIR}/XS.cpp)
add_custom_command(
        OUTPUT ${XS_MAIN_CPP}
        DEPENDS ${MyTypemap} ${XS_XSP_FILES} ${CMAKE_CURRENT_LIST_DIR}/xsp/typemap.xspt
        COMMAND COMMAND xsubpp -typemap typemap -output ${XS_MAIN_CPP} -hiertype ${XS_MAIN_XS}
)

# Define the Perl XS shared library.
if(APPLE)
    set(XS_SHARED_LIBRARY_TYPE MODULE)
else()
    set(XS_SHARED_LIBRARY_TYPE SHARED)
endif()

## slic3r-prusa 1.31.4

=== debian/changelog ===
slic3r-prusa (1.31.4-1) unstable; urgency=medium

  * Initial Debianization (Closes: #844222)

 -- Chow Loong Jin <hyperair@debian.org>  Sun, 13 Nov 2016 21:09:27 +0800

=== debian/control ===
Source: slic3r-prusa
Section: perl
Priority: optional
Maintainer: Debian 3-D Printing Packages <3dprinter-general@lists.alioth.debian.org>
Uploaders: Chow Loong Jin <hyperair@debian.org>
Build-Depends: debhelper (>= 9.20120312),
               help2man,
               libboost-all-dev,
               libglew-dev,
               libboost-geometry-utils-perl,
               libclass-xsaccessor-perl,
               libencode-locale-perl,
               perl (>= 5.19.1) | libextutils-parsexs-perl (>= 3.180004),
               libextutils-typemaps-default-perl,
               perl,
               libio-stringy-perl,
               libmath-convexhull-monotonechain-perl,
               libmath-geometry-voronoi-perl,
               libmath-planepath-perl,
               libmodule-build-withxspp-perl,
               libmoo-perl,
               libopengl-perl,
               libstorable-perl,
               libtime-hires-perl,
               libwx-perl,
               libxml-sax-expatxs-perl,
               libdevel-checklib-perl,
               xfonts-base,
               xvfb,
               xauth
Standards-Version: 3.9.8
Homepage: http://github.com/prusa3d/slic3r
Vcs-Git: https://anonscm.debian.org/git/3dprinter/packages/slic3r-prusa.git
Vcs-Browser: https://anonscm.debian.org/git/3dprinter/packages/slic3r-prusa.git

Package: slic3r-prusa
Architecture: any
Depends: libboost-geometry-utils-perl,
         libencode-locale-perl,
         libio-stringy-perl,
         libmath-convexhull-monotonechain-perl,
         libmath-geometry-voronoi-perl,
         libmath-planepath-perl,
         libmoo-perl,
         libstorable-perl,
         libtime-hires-perl,
         ${misc:Depends},
         ${perl:Depends},
         ${shlibs:Depends}
Recommends: libclass-xsaccessor-perl,
            libopengl-perl,
            libwx-perl,
            libwx-glcanvas-perl,
            libxml-sax-expatxs-perl,
            libpdf-api2-perl,
            libio-all-perl,
            libsvg-perl
Description: G-code generator for 3D printers
 Slic3r converts digital 3D models into printing instructions (G-code)
 for your 3D printer. It cuts the model into horizontal slices (layers),
 generates toolpaths to fill them and calculates the amount of material
 to be extruded.
 .
 Slic3r supports input in the STL, AMF and OBJ formats, and can output
 G-code for several series of 3D printers, including RepRap, Ultimaker,
 Makerbot, as well as SVG files for DLP printers.
 .
 It can be used with a graphical interface, or in batch mode via the
 command-line.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

export SLIC3R_NO_AUTO=yes

build_args = \
	--install_path arch=/usr/lib/slic3r-prusa/

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -Dxs -- $(build_args)

override_dh_auto_build:
	xvfb-run -a dh_auto_build -Dxs --parallel -- $(build_args)

override_dh_auto_clean:
	dh_auto_clean -Dxs
	rm -rf xs/Build xs/MYMETA.json xs/MYMETA.yml xs/_build/ xs/blib/ xs/buildtmp/
	dh_auto_clean

override_dh_auto_test:
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	prove -v -Ilib -Ixs/blib/arch -Ixs/blib/lib t xs/t
endif

override_dh_auto_install:
	dh_auto_install -Dxs -- $(build_args)

	# Install Slic3r Perl module
	mkdir -p $(CURDIR)/debian/slic3r-prusa/usr/lib/slic3r-prusa
	cp -r lib/* $(CURDIR)/debian/slic3r-prusa/usr/lib/slic3r-prusa

	# Install Slic3r in PATH
	mkdir -p $(CURDIR)/debian/slic3r-prusa/usr/bin
	cp slic3r.pl $(CURDIR)/debian/slic3r-prusa/usr/bin/slic3r-prusa

	# Install Slic3r resources in /usr/share/slic3r-prusa
	mkdir -p $(CURDIR)/debian/slic3r-prusa/usr/share
	cp -r var $(CURDIR)/debian/slic3r-prusa/usr/share/slic3r-prusa
	chmod 644 $(CURDIR)/debian/slic3r-prusa/usr/share/slic3r-prusa/*.png

	# Install zsh completion
	mkdir -p $(CURDIR)/debian/slic3r-prusa/usr/share/zsh/vendor-completions
	cp utils/zsh/functions/_slic3r $(CURDIR)/debian/slic3r-prusa/usr/share/zsh/vendor-completions/_slic3r-prusa

=== debian/watch ===
version=3

opts="filenamemangle=s/(?:.*)?v?(\d[\d\.]*)\.tar\.gz/slic3r-$1.tar.gz/,dversionmangle=s/\+dfsg\d*//,repacksuffix=+dfsg" \
  https://github.com/prusa3d/Slic3r/tags (?:.*/)?version_(\d[\d\.]*)\.tar\.gz

## slic3r-prusa 1.31.6

=== debian/changelog ===
slic3r-prusa (1.31.6-1) unstable; urgency=medium

  * [c435c86] Imported Upstream version 1.31.6

 -- Chow Loong Jin <hyperair@debian.org>  Wed, 21 Dec 2016 23:17:00 +0800

## slic3r-prusa 1.37.0+dfsg

=== debian/changelog ===
slic3r-prusa (1.37.0+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix "Loadable library and perl binary mismatch":
    add override_dh_perl in debian/rules to make dh_perl search for perl
    modules in the private directory as well.
    (Closes: #872275)

 -- gregor herrmann <gregoa@debian.org>  Wed, 23 Aug 2017 19:17:28 +0200

slic3r-prusa (1.37.0+dfsg-1) unstable; urgency=medium

  * [3561f7e] New upstream version 1.37.0+dfsg

 -- Chow Loong Jin <hyperair@debian.org>  Sun, 06 Aug 2017 01:04:13 +0800

slic3r-prusa (1.36.2+dfsg-1) unstable; urgency=medium

  * [db314bf] New upstream version 1.36.2+dfsg

 -- Chow Loong Jin <hyperair@debian.org>  Mon, 31 Jul 2017 21:26:36 +0800

slic3r-prusa (1.36.0+dfsg-1) unstable; urgency=medium

  * [35f30b1] New upstream version 1.36.0+dfsg

 -- Chow Loong Jin <hyperair@debian.org>  Tue, 25 Jul 2017 01:46:22 +0800

slic3r-prusa (1.35.5+dfsg-1) experimental; urgency=medium

  * [e4a7131] New upstream version 1.35.5+dfsg

 -- Chow Loong Jin <hyperair@debian.org>  Sun, 18 Jun 2017 19:38:51 +0800

slic3r-prusa (1.35.3+dfsg-2) experimental; urgency=medium

  * [76eb163] New upstream version 1.35.3+dfsg

 -- Chow Loong Jin <hyperair@debian.org>  Wed, 14 Jun 2017 23:11:47 +0800

slic3r-prusa (1.35.2+dfsg-1) experimental; urgency=medium

  * [c5c442c] New upstream version 1.35.2+dfsg

 -- Chow Loong Jin <hyperair@debian.org>  Fri, 09 Jun 2017 01:58:31 +0800

slic3r-prusa (1.35.1+dfsg-1) experimental; urgency=medium

  * [83eeeb5] New upstream version 1.35.1+dfsg

 -- Chow Loong Jin <hyperair@debian.org>  Sun, 04 Jun 2017 02:04:02 +0800

slic3r-prusa (1.35.0+dfsg-1) experimental; urgency=medium

  * [f28744f] New upstream version 1.35.0+dfsg

 -- Chow Loong Jin <hyperair@debian.org>  Tue, 23 May 2017 00:42:11 +0800

slic3r-prusa (1.34.1+dfsg-1) experimental; urgency=medium

  * [56183a6] Imported Upstream version 1.34.1+dfsg

 -- Chow Loong Jin <hyperair@debian.org>  Fri, 07 Apr 2017 01:07:46 +0800

slic3r-prusa (1.34.0+dfsg-1) experimental; urgency=medium

  * [0cfd53e] Build-dep on libtbb-dev
  * [43d066f] Delete glew and expat
  * [b7d8afa] Rename Use-system-GLEW.patch.
    We need to unbundle a couple of other libs.
  * [5175bc5] Fix expat include
  * [88a0b44] Link against libexpat
  * [be8218c] Exclude more bundled libraries
  * [3a32f7f] Imported Upstream version 1.34.0+dfsg
  * [a157bd0] Imported Upstream version 1.34.0
  * [d9d46a9] Refresh patches
  * [0220070] Build-dep on libeigen3-dev

 -- Chow Loong Jin <hyperair@debian.org>  Thu, 06 Apr 2017 01:16:59 +0800

slic3r-prusa (1.33.8-1) experimental; urgency=medium

  * [0c4401b] Imported Upstream version 1.33.8

 -- Chow Loong Jin <hyperair@debian.org>  Wed, 22 Feb 2017 22:56:38 +0800

slic3r-prusa (1.33.7-1) experimental; urgency=medium

  * [4d19e89] Imported Upstream version 1.33.7

 -- Chow Loong Jin <hyperair@debian.org>  Tue, 21 Feb 2017 08:59:23 +0800

slic3r-prusa (1.33.5-1) experimental; urgency=medium

  * [7fba4b2] Imported Upstream version 1.33.5

 -- Chow Loong Jin <hyperair@debian.org>  Sat, 18 Feb 2017 01:19:14 +0800

slic3r-prusa (1.33.3-1) experimental; urgency=medium

  * [4bfc62b] Imported Upstream version 1.33.3

 -- Chow Loong Jin <hyperair@debian.org>  Sat, 11 Feb 2017 17:32:12 +0800

slic3r-prusa (1.33.2-1) experimental; urgency=medium

  * [f895ab7] Imported Upstream version 1.33.2

 -- Chow Loong Jin <hyperair@debian.org>  Fri, 13 Jan 2017 02:20:05 +0800

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,9 @@
 Build-Depends: debhelper (>= 9.20120312),
                help2man,
                libboost-all-dev,
+               libtbb-dev,
                libglew-dev,
+               libeigen3-dev,
                libboost-geometry-utils-perl,
                libclass-xsaccessor-perl,
                libencode-locale-perl,

=== debian/rules ===
--- 
+++ 
@@ -45,3 +45,6 @@
 	# Install zsh completion
 	mkdir -p $(CURDIR)/debian/slic3r-prusa/usr/share/zsh/vendor-completions
 	cp utils/zsh/functions/_slic3r $(CURDIR)/debian/slic3r-prusa/usr/share/zsh/vendor-completions/_slic3r-prusa
+
+override_dh_perl:
+	dh_perl /usr/lib/slic3r-prusa

## slic3r-prusa 1.39.1+dfsg

=== CMakeLists.txt ===
# Boost 1.63 requires CMake 3.7 or newer
cmake_minimum_required(VERSION 2.8)

project(Slic3r)

if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "No build type selected, default to Release")
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Build type (default Release)" FORCE)
endif()

if(DEFINED ENV{SLIC3R_STATIC})
	set(SLIC3R_STATIC_INITIAL $ENV{SLIC3R_STATIC})
else()
	if (MSVC OR MINGW OR APPLE)
		set(SLIC3R_STATIC_INITIAL 1)
	else()
		set(SLIC3R_STATIC_INITIAL 0)
	endif()
endif()

option(SLIC3R_STATIC 			"Compile Slic3r with static libraries (Boost, TBB, glew)" ${SLIC3R_STATIC_INITIAL})
option(SLIC3R_GUI    			"Compile Slic3r with GUI components (OpenGL, wxWidgets)" 1)
option(SLIC3R_PRUSACONTROL		"Compile Slic3r with the PrusaControl prject file format (requires wxWidgets base library)" 1)
option(SLIC3R_PROFILE 			"Compile Slic3r with an invasive Shiny profiler" 0)
option(SLIC3R_HAS_BROKEN_CROAK 	"Compile Slic3r for a broken Strawberry Perl 64bit" 0)
option(SLIC3R_MSVC_COMPILE_PARALLEL "Compile on Visual Studio in parallel" 1)

if (MSVC AND SLIC3R_MSVC_COMPILE_PARALLEL)
	add_compile_options(/MP)
endif ()

# Find the Perl interpreter, add local-lib to PATH and PERL5LIB environment variables,
# so the locally installed modules (mainly the Alien::wxPerl) will be reached.
if (WIN32)
    set(ENV_PATH_SEPARATOR ";")
else()
    set(ENV_PATH_SEPARATOR ":")
endif()
set(ENV{PATH}     "${PROJECT_SOURCE_DIR}/local-lib/bin${ENV_PATH_SEPARATOR}$ENV{PATH}")
set(ENV{PERL5LIB} "${PROJECT_SOURCE_DIR}/local-lib/lib/perl${ENV_PATH_SEPARATOR}$ENV{PERL5LIB}")
message("PATH: $ENV{PATH}")
message("PERL5LIB: $ENV{PERL5LIB}")
find_package(Perl REQUIRED)

add_subdirectory(xs)

enable_testing ()
get_filename_component(PERL_BIN_PATH "${PERL_EXECUTABLE}" DIRECTORY)
add_test (NAME xs COMMAND "${PERL_EXECUTABLE}" ${PERL_BIN_PATH}/prove -I ${PROJECT_SOURCE_DIR}/local-lib/lib/perl5 WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/xs)
add_test (NAME integration COMMAND "${PERL_EXECUTABLE}" ${PERL_BIN_PATH}/prove WORKING_DIRECTORY ${PROJECT_SOURCE_DIR})

install(PROGRAMS slic3r.pl DESTINATION bin RENAME slic3r-prusa3d)

file(GLOB MyVar var/*.png)
install(FILES ${MyVar} DESTINATION share/slic3r-prusa3d)
install(FILES lib/Slic3r.pm DESTINATION lib/slic3r-prusa3d)
install(DIRECTORY lib/Slic3r DESTINATION lib/slic3r-prusa3d)

=== xs/CMakeLists.txt ===
--- 
+++ 
@@ -26,6 +26,7 @@
 if(WIN32)
     # BOOST_ALL_NO_LIB: Avoid the automatic linking of Boost libraries on Windows. Rather rely on explicit linking.
     add_definitions(-D_USE_MATH_DEFINES -D_WIN32 -DBOOST_ALL_NO_LIB)
+    # -D_ITERATOR_DEBUG_LEVEL)
 endif()
 
 add_definitions(-DwxUSE_UNICODE -D_UNICODE -DUNICODE)
@@ -162,12 +163,18 @@
 )
 
 add_library(libslic3r_gui STATIC
+    ${LIBDIR}/slic3r/GUI/AppConfig.cpp
+    ${LIBDIR}/slic3r/GUI/AppConfig.hpp
     ${LIBDIR}/slic3r/GUI/3DScene.cpp
     ${LIBDIR}/slic3r/GUI/3DScene.hpp
     ${LIBDIR}/slic3r/GUI/GLShader.cpp
     ${LIBDIR}/slic3r/GUI/GLShader.hpp
     ${LIBDIR}/slic3r/GUI/Preset.cpp
     ${LIBDIR}/slic3r/GUI/Preset.hpp
+    ${LIBDIR}/slic3r/GUI/PresetBundle.cpp
+    ${LIBDIR}/slic3r/GUI/PresetBundle.hpp
+    ${LIBDIR}/slic3r/GUI/PresetHints.cpp
+    ${LIBDIR}/slic3r/GUI/PresetHints.hpp
     ${LIBDIR}/slic3r/GUI/GUI.cpp
     ${LIBDIR}/slic3r/GUI/GUI.hpp
 )
@@ -279,6 +286,7 @@
     ${XSP_DIR}/GCodeSender.xsp
     ${XSP_DIR}/Geometry.xsp
     ${XSP_DIR}/GUI.xsp
+    ${XSP_DIR}/GUI_AppConfig.xsp
     ${XSP_DIR}/GUI_3DScene.xsp
     ${XSP_DIR}/GUI_Preset.xsp
     ${XSP_DIR}/Layer.xsp
@@ -312,13 +320,3 @@
 set(XS_MAIN_CPP ${CMAKE_CURRENT_BINARY_DIR}/XS.cpp)
 add_custom_command(
         OUTPUT ${XS_MAIN_CPP}
-        DEPENDS ${MyTypemap} ${XS_XSP_FILES} ${CMAKE_CURRENT_LIST_DIR}/xsp/typemap.xspt
-        COMMAND COMMAND xsubpp -typemap typemap -output ${XS_MAIN_CPP} -hiertype ${XS_MAIN_XS}
-)
-
-# Define the Perl XS shared library.
-if(APPLE)
-    set(XS_SHARED_LIBRARY_TYPE MODULE)
-else()
-    set(XS_SHARED_LIBRARY_TYPE SHARED)
-endif()

=== debian/changelog ===
slic3r-prusa (1.39.1+dfsg-3) unstable; urgency=medium

  * [0f31b95] Reduce debug info to avoid running out of address space on mips.
    Thanks to Adrian Bunk <bunk@debian.org> (Closes: #895214)

 -- Chow Loong Jin <hyperair@debian.org>  Tue, 10 Apr 2018 15:01:30 +0800

slic3r-prusa (1.39.1+dfsg-2) unstable; urgency=medium

  * [3fb5ec7] Fix format-security FTBFS (Closes: #892959)

 -- Chow Loong Jin <hyperair@debian.org>  Mon, 19 Mar 2018 12:17:00 +0800

slic3r-prusa (1.39.1+dfsg-1) unstable; urgency=medium

  * [f77b280] debian/watch: Fix filenamemangle
  * [91a4788] New upstream version 1.39.1+dfsg
  * [c8af33b] Refresh patches
  * [136dd9c] Fix resources installation
  * [b14e7ae] Update icon symlinks for new icon path

 -- Chow Loong Jin <hyperair@debian.org>  Mon, 12 Mar 2018 03:47:30 +0800

slic3r-prusa (1.39.0+dfsg-1) unstable; urgency=medium

  * [280aee8] New upstream version 1.39.0+dfsg

 -- Chow Loong Jin <hyperair@debian.org>  Tue, 23 Jan 2018 01:43:03 +0800

slic3r-prusa (1.38.0+dfsg-1) unstable; urgency=medium

  * [df02f1c] New upstream version 1.38.0+dfsg
  * [7eec4d5] Drop upstreamed admesh big-endian patch
  * [ac81797] Bump Standards-Version to 4.1.1

 -- Chow Loong Jin <hyperair@debian.org>  Fri, 03 Nov 2017 23:02:51 +0800

slic3r-prusa (1.37.1+dfsg2-3) unstable; urgency=medium

  * [e6013ee] Run ctest with the verbose flag.
    This should fix the FTBFS on hppa caused by the lack of output during tests.

 -- Chow Loong Jin <hyperair@debian.org>  Wed, 04 Oct 2017 14:39:48 +0800

slic3r-prusa (1.37.1+dfsg2-2) unstable; urgency=medium

  * [7337428] Ack 1.37.0+dfsg-1.1 NMU:
    - Fix "Loadable library and perl binary mismatch":
      add override_dh_perl in debian/rules to make dh_perl search for perl
      modules in the private directory as well. (Closes: #872275)
  * [b962ed5] Import patch that fixes big-endian support in admesh
    (Closes: #869638)
  * [96ddc54] Bump Standards-Version
  * [8fd9f76] Update StartupWMClass.
  * [d077f2a] Update slic3r-prusa's desktop to open files

 -- Chow Loong Jin <hyperair@debian.org>  Mon, 02 Oct 2017 02:24:50 +0800

slic3r-prusa (1.37.1+dfsg2-1) unstable; urgency=medium

  * [1528472] New upstream version 1.37.1+dfsg2
    - Respin the tarball -- looks like the 1.37.1 tarball first downloaded was
      actually 1.34.1.
  * [6a3ab05] Refresh patches
  * [53ce34f] Use cmake build system
  * [facbb65] Set BUILD_TESTING=1
  * [595f15c] Set CMAKE_BUILD_TYPE=Release
  * [eb42e7c] Build-dep on local::lib
  * [eafd98e] Fix up paths.
    Things are now in slic3r-prusa3d instead of slic3r-prusa.
  * [82955ab] Fix up paths in patches
  * [0c723ea] Update manpage
  * [2be9304] Fix line breaking issues in manpage

 -- Chow Loong Jin <hyperair@debian.org>  Wed, 27 Sep 2017 23:54:15 +0800

slic3r-prusa (1.37.1+dfsg-1) unstable; urgency=medium

  * [21d7565] New upstream version 1.37.1+dfsg

 -- Chow Loong Jin <hyperair@debian.org>  Wed, 20 Sep 2017 22:43:28 +0800

=== debian/control ===
--- 
+++ 
@@ -4,6 +4,7 @@
 Maintainer: Debian 3-D Printing Packages <3dprinter-general@lists.alioth.debian.org>
 Uploaders: Chow Loong Jin <hyperair@debian.org>
 Build-Depends: debhelper (>= 9.20120312),
+               cmake,
                help2man,
                libboost-all-dev,
                libtbb-dev,
@@ -16,6 +17,7 @@
                libextutils-typemaps-default-perl,
                perl,
                libio-stringy-perl,
+               liblocal-lib-perl,
                libmath-convexhull-monotonechain-perl,
                libmath-geometry-voronoi-perl,
                libmath-planepath-perl,
@@ -30,7 +32,7 @@
                xfonts-base,
                xvfb,
                xauth
-Standards-Version: 3.9.8
+Standards-Version: 4.1.1
 Homepage: http://github.com/prusa3d/slic3r
 Vcs-Git: https://anonscm.debian.org/git/3dprinter/packages/slic3r-prusa.git
 Vcs-Browser: https://anonscm.debian.org/git/3dprinter/packages/slic3r-prusa.git

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

# less debug info to avoid running out of address space
ifneq (,$(filter $(DEB_HOST_ARCH), mips mipsel))
	export DEB_CXXFLAGS_MAINT_APPEND += -g1
endif

%:
	dh $@ --buildsystem=cmake --parallel

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- -DBUILD_TESTING=1 -DCMAKE_BUILD_TYPE=Release

override_dh_auto_test:
	dh_auto_test -- ARGS=-V

override_dh_perl:
	dh_perl /usr/lib/slic3r-prusa3d

## slic3r-prusa 1.39.2+dfsg

=== debian/changelog ===
slic3r-prusa (1.39.2+dfsg-1build3) disco; urgency=medium

  * No-change rebuild against latest glew

 -- Jeremy Bicha <jbicha@ubuntu.com>  Fri, 23 Nov 2018 20:05:23 -0500

slic3r-prusa (1.39.2+dfsg-1build2) disco; urgency=medium

  * No-change rebuild for the perl 5.28 transition.

 -- Adam Conrad <adconrad@ubuntu.com>  Fri, 02 Nov 2018 19:48:03 -0600

slic3r-prusa (1.39.2+dfsg-1build1) cosmic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 17 Jul 2018 12:50:31 +0000

slic3r-prusa (1.39.2+dfsg-1) unstable; urgency=medium

  * [7f4fb4d] New upstream version 1.39.2+dfsg

 -- Chow Loong Jin <hyperair@debian.org>  Mon, 07 May 2018 00:41:59 +0800

## slic3r-prusa 2.1.1%2Bdfsg

=== src/avrdude/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

add_definitions(-D_BSD_SOURCE -D_DEFAULT_SOURCE)   # To enable various useful macros and functions on Unices
remove_definitions(-D_UNICODE -DUNICODE)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED ON)

if (CMAKE_SYSTEM_NAME STREQUAL "Linux")
    # Workaround for an old CMake, which does not understand CMAKE_C_STANDARD.
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99 -Wall")
endif()


set(AVRDUDE_SOURCES
    arduino.c
    avr.c
    # avrftdi.c
    # avrftdi_tpi.c
    avrpart.c
    avr910.c
    bitbang.c
    buspirate.c
    butterfly.c
    config.c
    config_gram.c
    # confwin.c
    crc16.c
    # dfu.c
    fileio.c
    # flip1.c
    # flip2.c
    # ft245r.c
    # jtagmkI.c
    # jtagmkII.c
    # jtag3.c
    lexer.c
    linuxgpio.c
    lists.c
    # par.c
    pgm.c
    pgm_type.c
    pickit2.c
    pindefs.c
    # ppi.c
    # ppiwin.c
    safemode.c
    ser_avrdoper.c
    serbb_posix.c
    serbb_win32.c
    ser_posix.c
    ser_win32.c
    stk500.c
    stk500generic.c
    stk500v2.c
    term.c
    update.c
    # usbasp.c
    # usb_hidapi.c
    # usb_libusb.c
    # usbtiny.c
    wiring.c

    main.c
    avrdude-slic3r.hpp
    avrdude-slic3r.cpp
)
if (MSVC)
    set(AVRDUDE_SOURCES ${AVRDUDE_SOURCES}
        windows/utf8.c
        windows/unistd.cpp
        windows/getopt.c
    )
elseif (MINGW)
    set(AVRDUDE_SOURCES ${AVRDUDE_SOURCES}
        windows/utf8.c
    )
endif()

add_executable(avrdude-conf-gen conf-generate.cpp)

# Config file embedding
add_custom_command(
    DEPENDS avrdude-conf-gen ${CMAKE_CURRENT_SOURCE_DIR}/avrdude-slic3r.conf
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/avrdude-slic3r.conf.h
    COMMAND $<TARGET_FILE:avrdude-conf-gen> avrdude-slic3r.conf avrdude_slic3r_conf ${CMAKE_CURRENT_BINARY_DIR}/avrdude-slic3r.conf.h
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)

add_custom_target(gen_conf_h
   DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/avrdude-slic3r.conf.h
)

add_library(avrdude STATIC ${AVRDUDE_SOURCES})
add_dependencies(avrdude gen_conf_h)

add_executable(avrdude-slic3r main-standalone.cpp)
target_link_libraries(avrdude-slic3r avrdude)

encoding_check(avrdude)
encoding_check(avrdude-slic3r)

# Make avrdude-slic3r.conf.h includable:
target_include_directories(avrdude SYSTEM PRIVATE ${CMAKE_CURRENT_BINARY_DIR})

if (WIN32)
    target_compile_definitions(avrdude PRIVATE WIN32NATIVE=1)
    if(MSVC)
        target_include_directories(avrdude SYSTEM PRIVATE windows)    # So that sources find the getopt.h windows drop-in
    endif(MSVC)
endif()

=== src/libnest2d/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(Libnest2D)

if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
    # Update if necessary
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wno-long-long ")
endif()

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED)

# Add our own cmake module path.
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake_modules/)

option(LIBNEST2D_UNITTESTS "If enabled, googletest framework will be downloaded
    and the provided unit tests will be included in the build." OFF)

option(LIBNEST2D_BUILD_EXAMPLES "If enabled, examples will be built." OFF)

option(LIBNEST2D_HEADER_ONLY "If enabled static library will not be built." ON)

set(GEOMETRY_BACKENDS clipper boost eigen)
set(LIBNEST2D_GEOMETRIES clipper CACHE STRING "Geometry backend")
set_property(CACHE LIBNEST2D_GEOMETRIES PROPERTY STRINGS ${GEOMETRY_BACKENDS})
list(FIND GEOMETRY_BACKENDS ${LIBNEST2D_GEOMETRIES} GEOMETRY_TYPE)
if(${GEOMETRY_TYPE} EQUAL -1)
    message(FATAL_ERROR "Option ${LIBNEST2D_GEOMETRIES} not supported, valid entries are ${GEOMETRY_BACKENDS}")
endif()

set(OPTIMIZERS nlopt optimlib)
set(LIBNEST2D_OPTIMIZER nlopt CACHE STRING "Optimization backend")
set_property(CACHE LIBNEST2D_OPTIMIZER PROPERTY STRINGS ${OPTIMIZERS})
list(FIND OPTIMIZERS ${LIBNEST2D_OPTIMIZER} OPTIMIZER_TYPE)
if(${OPTIMIZER_TYPE} EQUAL -1)
    message(FATAL_ERROR "Option ${LIBNEST2D_OPTIMIZER} not supported, valid entries are ${OPTIMIZERS}")
endif()

add_library(libnest2d INTERFACE)

set(SRC_DIR ${PROJECT_SOURCE_DIR}/include)

set(LIBNEST2D_SRCFILES
    ${SRC_DIR}/libnest2d/libnest2d.hpp         # Templates only
    ${SRC_DIR}/libnest2d/geometry_traits.hpp
    ${SRC_DIR}/libnest2d/geometry_traits_nfp.hpp
    ${SRC_DIR}/libnest2d/common.hpp
    ${SRC_DIR}/libnest2d/optimizer.hpp
    ${SRC_DIR}/libnest2d/utils/metaloop.hpp
    ${SRC_DIR}/libnest2d/utils/rotfinder.hpp
    ${SRC_DIR}/libnest2d/utils/rotcalipers.hpp
    ${SRC_DIR}/libnest2d/utils/bigint.hpp
    ${SRC_DIR}/libnest2d/utils/rational.hpp
    ${SRC_DIR}/libnest2d/placers/placer_boilerplate.hpp
    ${SRC_DIR}/libnest2d/placers/bottomleftplacer.hpp
    ${SRC_DIR}/libnest2d/placers/nfpplacer.hpp
    ${SRC_DIR}/libnest2d/selections/selection_boilerplate.hpp
    ${SRC_DIR}/libnest2d/selections/filler.hpp
    ${SRC_DIR}/libnest2d/selections/firstfit.hpp
    ${SRC_DIR}/libnest2d/selections/djd_heuristic.hpp
    )

set(TBB_STATIC ON)
find_package(TBB QUIET)
if(TBB_FOUND)
    message(STATUS "Parallelization with Intel TBB")
    target_include_directories(libnest2d INTERFACE ${TBB_INCLUDE_DIRS})
    target_compile_definitions(libnest2d INTERFACE ${TBB_DEFINITIONS} -DUSE_TBB)
    if(MSVC)
       # Suppress implicit linking of the TBB libraries by the Visual Studio compiler.
       target_compile_definitions(libnest2d INTERFACE -D__TBB_NO_IMPLICIT_LINKAGE)
    endif()
    # The Intel TBB library will use the std::exception_ptr feature of C++11.
    target_compile_definitions(libnest2d INTERFACE -DTBB_USE_CAPTURED_EXCEPTION=0)

    find_package(Threads REQUIRED)
    target_link_libraries(libnest2d INTERFACE 
        tbb # VS debug mode needs linking this way:
        # ${TBB_LIBRARIES} 
        ${CMAKE_DL_LIBS}
        Threads::Threads
        )
else()
   find_package(OpenMP QUIET)

   if(OpenMP_CXX_FOUND)
       message(STATUS "Parallelization with OpenMP")
       target_include_directories(libnest2d INTERFACE OpenMP::OpenMP_CXX)
       target_link_libraries(libnest2d INTERFACE OpenMP::OpenMP_CXX)
   else()
       message("Parallelization with C++11 threads")
       find_package(Threads REQUIRED)
       target_link_libraries(libnest2d INTERFACE Threads::Threads)
   endif()
endif()

add_subdirectory(${SRC_DIR}/libnest2d/backends/${LIBNEST2D_GEOMETRIES})
target_link_libraries(libnest2d INTERFACE ${LIBNEST2D_GEOMETRIES}Backend)

add_subdirectory(${SRC_DIR}/libnest2d/optimizers/${LIBNEST2D_OPTIMIZER})
target_link_libraries(libnest2d INTERFACE ${LIBNEST2D_OPTIMIZER}Optimizer)

# target_sources(libnest2d INTERFACE ${LIBNEST2D_SRCFILES})
target_include_directories(libnest2d INTERFACE ${SRC_DIR})

if(NOT LIBNEST2D_HEADER_ONLY)
    set(LIBNAME libnest2d_${LIBNEST2D_GEOMETRIES}_${LIBNEST2D_OPTIMIZER})
    add_library(${LIBNAME} ${PROJECT_SOURCE_DIR}/src/libnest2d.cpp)
    target_link_libraries(${LIBNAME} PUBLIC libnest2d)
    target_compile_definitions(${LIBNAME} PUBLIC LIBNEST2D_STATIC)
endif()

if(LIBNEST2D_BUILD_EXAMPLES)

    add_executable(example     examples/main.cpp
    #                           tools/libnfpglue.hpp
    #                           tools/libnfpglue.cpp
                               tools/nfp_svgnest.hpp
                               tools/nfp_svgnest_glue.hpp
                               tools/svgtools.hpp
                               tests/printer_parts.cpp
                               tests/printer_parts.h
                               )

    if(NOT LIBNEST2D_HEADER_ONLY)
        target_link_libraries(example ${LIBNAME})
    else()
        target_link_libraries(example libnest2d)
    endif()
endif()

if(LIBNEST2D_UNITTESTS)
    add_subdirectory(${PROJECT_SOURCE_DIR}/tests)
endif()

=== src/slic3r/CMakeLists.txt ===
project(libslic3r_gui)
cmake_minimum_required(VERSION 2.6)

include(PrecompiledHeader)

set(SLIC3R_GUI_SOURCES
    pchheader.cpp
    pchheader.hpp
    GUI/AboutDialog.cpp
    GUI/AboutDialog.hpp
    GUI/SysInfoDialog.cpp
    GUI/SysInfoDialog.hpp
    GUI/KBShortcutsDialog.cpp
    GUI/KBShortcutsDialog.hpp
    GUI/AppConfig.cpp
    GUI/AppConfig.hpp
    GUI/BackgroundSlicingProcess.cpp
    GUI/BackgroundSlicingProcess.hpp
    GUI/BitmapCache.cpp
    GUI/BitmapCache.hpp
    GUI/ConfigSnapshotDialog.cpp
    GUI/ConfigSnapshotDialog.hpp
    GUI/3DScene.cpp
    GUI/3DScene.hpp
    GUI/GLShader.cpp
    GUI/GLShader.hpp    
    GUI/GLCanvas3D.hpp
    GUI/GLCanvas3D.cpp
    GUI/GLCanvas3DManager.hpp
    GUI/GLCanvas3DManager.cpp
    GUI/Selection.hpp
    GUI/Selection.cpp    
    GUI/Gizmos/GLGizmos.hpp
    GUI/Gizmos/GLGizmosManager.cpp
    GUI/Gizmos/GLGizmosManager.hpp
    GUI/Gizmos/GLGizmoBase.cpp
    GUI/Gizmos/GLGizmoBase.hpp
    GUI/Gizmos/GLGizmoMove.cpp
    GUI/Gizmos/GLGizmoMove.hpp
    GUI/Gizmos/GLGizmoRotate.cpp
    GUI/Gizmos/GLGizmoRotate.hpp
    GUI/Gizmos/GLGizmoScale.cpp
    GUI/Gizmos/GLGizmoScale.hpp
    GUI/Gizmos/GLGizmoSlaSupports.cpp
    GUI/Gizmos/GLGizmoSlaSupports.hpp
    GUI/Gizmos/GLGizmoFlatten.cpp
    GUI/Gizmos/GLGizmoFlatten.hpp
    GUI/Gizmos/GLGizmoCut.cpp
    GUI/Gizmos/GLGizmoCut.hpp
    GUI/GLSelectionRectangle.cpp
    GUI/GLSelectionRectangle.hpp
    GUI/GLTexture.hpp
    GUI/GLTexture.cpp
    GUI/GLToolbar.hpp
    GUI/GLToolbar.cpp
    GUI/Preferences.cpp
    GUI/Preferences.hpp
    GUI/Preset.cpp
    GUI/Preset.hpp
    GUI/PresetBundle.cpp
    GUI/PresetBundle.hpp
    GUI/PresetHints.cpp
    GUI/PresetHints.hpp
    GUI/GUI.cpp
    GUI/GUI.hpp
    GUI/GUI_Preview.cpp
    GUI/GUI_Preview.hpp
    GUI/GUI_App.cpp
    GUI/GUI_App.hpp
    GUI/GUI_Utils.cpp
    GUI/GUI_Utils.hpp
    GUI/I18N.cpp
    GUI/I18N.hpp
    GUI/MainFrame.cpp
    GUI/MainFrame.hpp
    GUI/Plater.cpp
    GUI/Plater.hpp
    GUI/GUI_ObjectList.cpp
    GUI/GUI_ObjectList.hpp
    GUI/GUI_ObjectManipulation.cpp
    GUI/GUI_ObjectManipulation.hpp
    GUI/GUI_ObjectSettings.cpp
    GUI/GUI_ObjectSettings.hpp
    GUI/GUI_ObjectLayers.cpp
    GUI/GUI_ObjectLayers.hpp
    GUI/LambdaObjectDialog.cpp
    GUI/LambdaObjectDialog.hpp
    GUI/Tab.cpp
    GUI/Tab.hpp
    GUI/ConfigManipulation.cpp
    GUI/ConfigManipulation.hpp
    GUI/Field.cpp
    GUI/Field.hpp
    GUI/OptionsGroup.cpp
    GUI/OptionsGroup.hpp
    GUI/BedShapeDialog.cpp
    GUI/BedShapeDialog.hpp
    GUI/2DBed.cpp
    GUI/2DBed.hpp
    GUI/3DBed.cpp
    GUI/3DBed.hpp
    GUI/Camera.cpp
    GUI/Camera.hpp
    GUI/wxExtensions.cpp
    GUI/wxExtensions.hpp
    GUI/WipeTowerDialog.cpp
    GUI/WipeTowerDialog.hpp
    GUI/RammingChart.cpp
    GUI/RammingChart.hpp
    GUI/BonjourDialog.cpp
    GUI/BonjourDialog.hpp
    GUI/ButtonsDescription.cpp
    GUI/ButtonsDescription.hpp
    GUI/ImGuiWrapper.hpp
    GUI/ImGuiWrapper.cpp
    Config/Snapshot.cpp
    Config/Snapshot.hpp
    Config/Version.cpp
    Config/Version.hpp    
    Utils/ASCIIFolding.cpp
    Utils/ASCIIFolding.hpp
    Utils/Serial.cpp
    Utils/Serial.hpp
    GUI/ConfigWizard.cpp
    GUI/ConfigWizard.hpp
    GUI/MsgDialog.cpp
    GUI/MsgDialog.hpp
    GUI/UpdateDialogs.cpp
    GUI/UpdateDialogs.hpp
    GUI/FirmwareDialog.cpp
    GUI/FirmwareDialog.hpp
    GUI/ProgressIndicator.hpp
    GUI/ProgressStatusBar.hpp
    GUI/ProgressStatusBar.cpp
    GUI/PrintHostDialogs.cpp
    GUI/PrintHostDialogs.hpp
    Utils/Http.cpp
    Utils/Http.hpp
    Utils/FixModelByWin10.cpp
    Utils/FixModelByWin10.hpp
    Utils/OctoPrint.cpp
    Utils/OctoPrint.hpp
    Utils/Duet.cpp
    Utils/Duet.hpp
    Utils/PrintHost.cpp
    Utils/PrintHost.hpp
    Utils/Bonjour.cpp
    Utils/Bonjour.hpp
    Utils/PresetUpdater.cpp
    Utils/PresetUpdater.hpp
    Utils/UndoRedo.cpp
    Utils/UndoRedo.hpp
    Utils/HexFile.cpp
    Utils/HexFile.hpp
)

if (APPLE)
    list(APPEND SLIC3R_GUI_SOURCES
            Utils/RetinaHelperImpl.mm
            Utils/MacDarkMode.mm
        )
endif ()

add_library(libslic3r_gui STATIC ${SLIC3R_GUI_SOURCES})

encoding_check(libslic3r_gui)

target_link_libraries(libslic3r_gui libslic3r avrdude cereal imgui ${GLEW_LIBRARIES})
if (SLIC3R_PCH AND NOT SLIC3R_SYNTAXONLY)
    add_precompiled_header(libslic3r_gui pchheader.hpp FORCEINCLUDE)
endif ()

=== src/libnest2d/tests/CMakeLists.txt ===

# Try to find existing GTest installation
find_package(GTest 1.7)

if(NOT GTEST_FOUND)
    set(URL_GTEST "https://github.com/google/googletest.git" 
        CACHE STRING "Google test source code repository location.")

    message(STATUS "GTest not found so downloading from ${URL_GTEST}")
    # Go and download google test framework, integrate it with the build
    set(GTEST_LIBS_TO_LINK gtest gtest_main)

    if (CMAKE_VERSION VERSION_LESS 3.2)
        set(UPDATE_DISCONNECTED_IF_AVAILABLE "")
    else()
        set(UPDATE_DISCONNECTED_IF_AVAILABLE "UPDATE_DISCONNECTED 1")
    endif()

    include(DownloadProject)
    download_project(PROJ                googletest
                     GIT_REPOSITORY      ${URL_GTEST}
                     GIT_TAG             release-1.7.0
                     ${UPDATE_DISCONNECTED_IF_AVAILABLE}
    )

    # Prevent GoogleTest from overriding our compiler/linker options
    # when building with Visual Studio
    set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)

    add_subdirectory(${googletest_SOURCE_DIR}
                     ${googletest_BINARY_DIR}
                     )

    set(GTEST_INCLUDE_DIRS ${googletest_SOURCE_DIR}/include)

else()
    find_package(Threads REQUIRED)
    set(GTEST_LIBS_TO_LINK  ${GTEST_BOTH_LIBRARIES}  Threads::Threads)
endif()

add_executable(tests_clipper_nlopt
    test.cpp
    ../tools/svgtools.hpp
#   ../tools/libnfpglue.hpp
#  ../tools/libnfpglue.cpp
    printer_parts.h
    printer_parts.cpp
)

target_link_libraries(tests_clipper_nlopt libnest2d ${GTEST_LIBS_TO_LINK} )

target_include_directories(tests_clipper_nlopt PRIVATE BEFORE ${GTEST_INCLUDE_DIRS})

if(NOT LIBNEST2D_HEADER_ONLY)
    target_link_libraries(tests_clipper_nlopt ${LIBNAME})
else()
    target_link_libraries(tests_clipper_nlopt libnest2d)
endif()

add_test(libnest2d_tests tests_clipper_nlopt)
